#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>

static void error_fatal (char *message){
  perror (message);

  exit (EXIT_FAILURE);
}

static void sig_segv(int signo){
  if (signo == SIGSEGV){
    printf ("Our Segmentation fault handler: not the legal memory adress...\n");
    exit (EXIT_FAILURE);
  }
}

int main (int argc, char **argv){
  int *x;

  /* Registruje se handler za slucaj nedozvoljenog pristupa memoriji.
     Ukoliko se ne pozove funkcija signal, bice prijavljena greska
     Segmentation fault i prekinut program. */
  if (signal(SIGSEGV, sig_segv) == SIG_ERR)
    error_fatal ("signal error");

  /* Nedozovoljen pristup memoriji. */
  x[200000] = 3;


  return 0;
}

