#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>

static void error_fatal (char *message){
  /* Stampa se poruka o gresci. */
  perror (message);

  /* Prekida se program. */
  exit (EXIT_FAILURE);
}

/* Funkcija on_sigusr() je handler za SIGUSR1, SIGUSR2 i SIGINT signale. */
static void on_sigusr_sigint (int signo)
{
  /* U zavisnosti od tipa signala koji je uhvacen stampa se
     odgovarajuca poruka. */
  switch (signo)
    {
    case SIGUSR1:
      printf ("SIGUSR1 signal caught.\n");
      break;

    case SIGUSR2:
      printf ("SIGUSR2 signal caught.\n");
      break;

    case SIGINT:
      printf ("SIGINT signal caught.\n");
      break;
    }
}


/* Program demonstrira hvatanje signala. */
int main (int argc, char **argv){

  /* Postavlja se handler za SIGUSR1 signal. */
  if (signal (SIGUSR1, on_sigusr_sigint) == SIG_ERR)
    error_fatal (argv[0]);

  /* Postavlja se handler za SIGUSR2 signal. */
  if (signal (SIGUSR2, on_sigusr_sigint) == SIG_ERR)
    error_fatal (argv[0]);

  /* Postavlja se handler za SIGINT signal. */
  if (signal (SIGINT, on_sigusr_sigint) == SIG_ERR)
    error_fatal (argv[0]);

  /* Program u petlji ceka pojavu signala. */
  for (;;)
    pause ();

  /* Zavrsava se program. */
  exit (EXIT_SUCCESS);
}

