#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>

/* U ovoj funkciji se nista ne radi, jedina njena svrha je da bude
   pozvana kada dodje do signala SIGALRM umesto da bude izvrsena
   podrazumevana akcija (prekid programa).*/
static void sig_alrm(int signo){
  printf ("Sleeping is over...\n");
}

/* Nasa verzija funkcije sleep - ima vise mana o kojima se moze
   procitati u knjizi APUE. */
unsigned int sleep_our (unsigned int timeout){
  
  /* Postavlja se funkcija sig_alrm da bude pozvana kada dodje do
     signala SIGALRM. */
  if (signal(SIGALRM, sig_alrm) == SIG_ERR)
    return(timeout);

  /* Pokrece se hronometar (timer) na odgovarajuci broj sekundi. */
  alarm(timeout);

  /* Zaustaviti se dok ne dodje do signala. */
  pause();

  /* Novi poziv alarm funkcije; kada je argument 0 isključuje se
     prethnodni hronometar ako je postavljen. U ovom slucaju, poziv
     ove funkcije je nepotreban. */
  return (alarm(0));
}
int main (int argc, char **argv){
  sleep_our (2);

  return 0;
}

